select count(*) from sales NOLOCK

--ANSI Isolation Levels
0	Read Uncommitted (dirty reads)
1	Read Committed - DEFAULT
2	Repeatable Read (w/o inconsistent analysis)
3	Serializable (phantoms)

set statistics io on
go
--Absolutely accurate
select count(*) from member HOLDLOCK --prevents phantoms and inconsistent analysis
select count(*) from member SERIALIZABLE
-- OR for the session
set transaction isolation level serializable
select...

-- Fast but not guaranteed...
--Should be VERY close (but sometimes slow on larger and larger tables...)
USE pubs
select count(*) from titles
select count(title_id) from titles
select count(title) from titles
select count(pubdate) from titles
select count(type) from titles


go
select count(*) from titles 
select count(member_no) from member
go
--Estimate not guaranteed to be accurate BUT s/b close
SELECT rows, rowcnt
FROM sysindexes 
WHERE id = object_id('loanhist')
AND indid IN (0,1)
--AND indid < 2

SELECT rowcnt -- pref in SS2k
FROM sysindexes 
WHERE id = object_id('titles')
AND indid IN (0,1)

--    0    Heap (table doesn't have a CL Index)
--    1    Clustered Table
-- > 1    Nonclustered Indexes
-- 255    Text/Image BTree

-- OR 
sp_spaceused titles, true --without true it's an estimate 
			-- with true it's a scan and accurate and slower

create unique index memberind on member(member_no)
drop index member.memberind

-- Combining aggregates
select min(member_no), max(member_no), avg(member_no) 
from member

select min(member_no), (SELECT max(member_no) 
			from member) 
from member

select max(member_no) from member












